Subject: Re: [PATCH 2/2] netlink: add ethernet address policy types

From: Johannes Berg <[email-masked]>
Date: Thu, 13 Sep 2018 14:16:06 +0200

On Thu, 2018-09-13 at 14:12 +0200, Michal Kubecek wrote:
> On Thu, Sep 13, 2018 at 02:02:53PM +0200, Johannes Berg wrote:
> > On Thu, 2018-09-13 at 13:58 +0200, Michal Kubecek wrote:
> > 
> > > The code looks correct to me but I have some doubts. Having a special
> > > policy for MAC addresses may lead to adding one for IPv4 address (maybe
> > > not, we can use NLA_U32 for them), IPv6 addresses and other data types
> > > with fixed length. Wouldn't it be more helpful to add a variant of
> > > NLA_BINARY (NLA_BINARY_EXACT?) which would fail/warn if attribute length
> > > isn't equal to .len?
> > 
> > Yeah, I guess we could do that, and then
> > 
> > #define NLA_ETH_ADDR .len = ETH_ALEN, .type = NLA_BINARY_EXACT
> > #define NLA_IP6_ADDR .len = 16, .type = NLA_BINARY_EXACT
> > 
> > or so?
> 
> Maybe rather
> 
>   #define NLA_ETH_ADDR NLA_BINARY_EXACT, .len = ETH_ALEN
>   #define NLA_IP6_ADDR NLA_BINARY_EXACT, .len = sizeof(struct in6_addr)
> 
> so that one could write
> 
>   { .type = NLA_ETH_ADDR }

Yeah, that's possible. I considered it for a second, but it was slightly
too magical for my taste :-)

Better pick a different "namespace", perhaps NLA_POLICY_ETH_ADDR or so?

johannes